﻿package  {
    
    import flash.display.*;
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.events.TimerEvent;
    import flash.filters.GlowFilter;
    import flash.text.TextField;
    import flash.text.TextFieldAutoSize;
    import flash.text.TextFormat;
    import flash.utils.Timer;
    import net.hires.debug.Stats;
    
    /**
    * パフォーマンステスト用のテンプレ.
    * @author kawakita
    * @version 0.1
    */
    public class ScaledAndCacheAsBitmapRotation extends MovieClip{
        
        //------- CONST ------------------------------------------------------------------------
        //------- MEMBER -----------------------------------------------------------------------
        private var _stats:Stats;
        private var _sp:Sprite;
        
        //------- PUBLIC -----------------------------------------------------------------------
        
        /** コンストラクタ. */
        public function ScaledAndCacheAsBitmapRotation() {
            
            stage.align = StageAlign.TOP_LEFT;
            stage.showDefaultContextMenu = false;
            
            _sp = new Sprite();
            addChild( _sp );
            _sp.mouseChildren = false;
            _sp.mouseEnabled = false;
            
            _score = new TextField();
            _score.autoSize = TextFieldAutoSize.LEFT;
            _score.defaultTextFormat = new TextFormat( null, 60, 0xffffff, true)
            _score.selectable = false;
            _score.mouseEnabled = false;
            _score.filters = [ new GlowFilter( 0, 0.5, 20, 20, 20, 3 ) ];
            addChild( _score )
            
            var startBtn:SimpleButton = new ClickToStart();
            startBtn.x = ( stage.stageWidth - startBtn.width ) / 2;
            startBtn.y = ( stage.stageHeight - startBtn.height ) / 2;
            startBtn.addEventListener(MouseEvent.CLICK, _onClick );
            addChild( startBtn )
            
            _stats = new Stats();
            addChild( _stats );
            
        }
        
        //------- PRIVATE ----------------------------------------------------------------------
        private var _cnt:uint;
        private var _timer:Timer;
        private var _timer2:Timer;
        private var _score:TextField;
        
        private function _onClick(e:MouseEvent):void {
            e.target.removeEventListener(MouseEvent.CLICK, _onClick );
            removeChild( e.target as DisplayObject );
            _cnt = 0;
            addEventListener(Event.ENTER_FRAME, _onEnterFrame );
            _timer = new Timer( 1000 );
            _timer.addEventListener( TimerEvent.TIMER, _onTimer );
            _timer.start();
            _timer2 = new Timer(100);
            _timer2.addEventListener( TimerEvent.TIMER, _onTimer2 );
            _timer2.start();
        }
        
        private function _onTimer(e:TimerEvent):void {
            if ( _cnt < 10 || 5000 <= _sp.numChildren ) {
                removeEventListener(Event.ENTER_FRAME, _onEnterFrame );
                _timer.stop();
                _timer2.stop();
                _score.text = _sp.numChildren.toString();
                _score.x = ( stage.stageWidth - _score.textWidth ) / 2;
                _score.y = ( stage.stageHeight - _score.textHeight ) / 2;
                Graphic4.stop();
                return;
            }
            for ( var i:uint = 0; i < 20; i++ ){
                _sp.addChild( new Graphic4() );
            }
            _cnt = 0;
        }
        
        private function _onTimer2(e:TimerEvent):void {
            for ( var i:uint = 0; i < 20; i++ ) _sp.addChild( new Graphic4() );
        }
        
        private function _onEnterFrame(e:Event):void {
            _cnt++;
        }
        
        //------- PROTECTED --------------------------------------------------------------------
        //------- INTERNAL ---------------------------------------------------------------------
    
    }
    
}